#!/usr/bin/env python3
"""Reusable library - LDD

MIT License

Copyright (c) 2023 JJR

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in all
copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
SOFTWARE.
"""

import os
import pathlib
import lddwrap


def get_deps(filepath):
    env = os.environ.copy()
    #env['LD_LIBRARY_PATH'] = "some/important/path"
    try:
        path = pathlib.Path(filepath)
        deps = lddwrap.list_dependencies(path=path, env=env)
        _deps = {}
        for d in deps:
            dd = _deps[d.soname] = {}
            dd['soname'] = d.soname
            dd['path'] = d.path
        return _deps
    except Exception as e:
        print('ERROR: get_deps', e)
        return None


if __name__ == "__main__":
    d = get_deps('/bin/ls')
    for i in d:
        print(i, d[i])
